<template>
  <nav
    class="navbar navbar-expand-lg navbar-dark bg-primary flex-nowrap justify-content-sm-between justify-content-md-end"
  >
    <transition name="slide-x-left">
      <router-link v-if="!searchVisible" class="navbar-brand" to="/">
        <logo />
      </router-link>
    </transition>

    <transition name="slide-x-left">
      <ul class="nav mr-auto" v-if="!searchVisible">
        <li
          v-if="isAtHome"
          class="nav-item d-flex justify-content-center align-items-center"
        >
          <span class="px-3 py-2 text-white">
            Home
          </span>
        </li>
        <li v-if="!isAtHome">
          <div class="dropdown px-3 py-2">
            <button
              class="btn btn-primary dropdown-toggle"
              type="button"
              data-toggle="dropdown"
              aria-haspopup="true"
              aria-expanded="false"
            >
              {{ currentBoard?.name }}
            </button>
            <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
              <router-link
                class="dropdown-item"
                v-for="(board, index) in boards"
                :key="index"
                :to="{ name: 'kanban', params: { boardId: board.id } }"
              >
                {{ board.name }}
              </router-link>
            </div>
          </div>
        </li>
      </ul>
    </transition>

    <transition name="slide-x-right">
      <form
        v-if="searchVisible"
        tag="form"
        class="search form-inline my-2 my-lg-0"
      >
        <div class="w-25 d-flex justify-content-end">
          <button
            @click.prevent="toogleSearch(false)"
            type="submit"
            class="btn btn-primary d-block d-md-none mr-2"
          >
            <app-icon icon="arrow-left"></app-icon>
          </button>
        </div>
        <div class="w-75">
          <input
            @blur="toogleSearch(false)"
            class="form-control w-100"
            type="search"
            v-model="searchTerm"
            placeholder="Search"
            aria-label="Search"
          />
        </div>
      </form>
    </transition>

    <div class="search mx-2">
      <button
        type="submit"
        @click.prevent="toogleSearch(!searchVisible)"
        class="btn btn-primary"
      >
        <app-icon icon="search"></app-icon>
      </button>
    </div>
    <teleport to="body">
      <overlay :open="searchVisible" />
    </teleport>
    <teleport to="body">
      <transition>
        <search-results
          v-if="searchVisible"
          :boards="boards"
          :cards="boards[0].lists[0].cards"
        />
      </transition>
    </teleport>
  </nav>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import { Board, LocalDatabase } from "@/core/database";
import Logo from "../components/Logo.vue";
import Overlay from "../components/Overlay.vue";
import SearchResults from "../components/SearchResults.vue";
import { BoardRepository } from "@/core/repositories";
import { SubSink } from "subsink";
import { RouteLocation } from "vue-router";
import { throwError } from "rxjs";

export default defineComponent({
  components: { Logo, Overlay, SearchResults },
  created() {
    LocalDatabase.getInstance().then(async (db) => {
      this.boardRepository = BoardRepository.getInstance(db);
      const boardObservable = await this.boardRepository.watchAllItems();
      this.subSink.sink = boardObservable.subscribe((boards) => {
        if (boards) {
          this.boards = boards;
        }
      });
    });
  },
  data() {
    return {
      searchTerm: "",
      searchVisible: false,
      currentBoard: {} as Board | null,
      boardRepository: {} as BoardRepository,
      boards: [] as Board[],
      subSink: new SubSink(),
    };
  },
  computed: {
    isAtHome(): boolean {
      if (this.currentBoard) return false;
      return true;
    },
  },
  watch: {
    $route(to: RouteLocation) {
      if (Object.keys(to.params).length < 1) {
        this.currentBoard = null;
        return;
      }
      const board = this.boards.find((board) => board.id === to.params.boardId);
      if (board) {
        this.currentBoard = board;
      }
    },
    boards() {
      if (Object.keys(this.$route.params).length < 1) {
        this.currentBoard = null;
        return;
      }
      const board = this.boards.find(
        (board) => board.id === this.$route.params.boardId
      );
      if (board) {
        this.currentBoard = board;
      }
    },
  },
  methods: {
    toogleSearch(state = false) {
      console.log(state);
      this.searchVisible = state;
    },
  },
});
</script>

<style scoped>
.navbar {
  height: 70px;
}

.search {
  z-index: 1040;
}

/* Slide Transition */
.slide-x-right-enter-active,
.slide-x-right-leave-active,
.slide-x-left-enter-active,
.slide-x-left-leave-active {
  transition-property: opacity, transform;
  transition-duration: 200ms;
  transition-timing-function: ease-in;
}

.slide-x-left-enter-from,
.slide-x-left-leave-to {
  opacity: 0;
  transform: translateX(-200%);
}

.slide-x-right-enter-from,
.slide-x-right-leave-to {
  opacity: 0;
  transform: translateX(200%);
}
</style>
